<?php
function expert_videographer_header_settings( $wp_customize ) {
$selective_refresh = isset( $wp_customize->selective_refresh ) ? 'postMessage' : 'refresh';

    // Site Title Hide/ Show Setting // 
	$wp_customize->add_setting( 
		'expert_videographer_site_title_setting' , 
			array(
			'default' => '1',
			'sanitize_callback' => 'expert_videographer_sanitize_checkbox',
			'capability' => 'edit_theme_options',
		) 
	);
	
	$wp_customize->add_control(
	'expert_videographer_site_title_setting', 
		array(
			'label'	      => esc_html__( 'Hide / Show Site Title', 'expert-videographer' ),
			'section'     => 'title_tagline',
			'settings'    => 'expert_videographer_site_title_setting',
			'type'        => 'checkbox'
		) 
	);

	// Tagline Hide/ Show Setting // 
	$wp_customize->add_setting( 
		'expert_videographer_tagline_setting' , 
			array(
			'default' => '',
			'sanitize_callback' => 'expert_videographer_sanitize_checkbox',
			'capability' => 'edit_theme_options',
		) 
	);
	
	$wp_customize->add_control(
	'expert_videographer_tagline_setting', 
		array(
			'label'	      => esc_html__( 'Hide / Show Tagline', 'expert-videographer' ),
			'section'     => 'title_tagline',
			'settings'    => 'expert_videographer_tagline_setting',
			'type'        => 'checkbox'
		) 
	);

	// Add the setting for logo width
	$wp_customize->add_setting(
		'expert_videographer_logo_width',
		array(
			'sanitize_callback' => 'expert_videographer_sanitize_logo_width',
			'priority'          => 2,
		)
	);

	// Add control for logo width
	$wp_customize->add_control( 
		'expert_videographer_logo_width',
		array(
			'label'     => __('Logo Width', 'expert-videographer'),
			'section'   => 'title_tagline',
			'type'      => 'number',
			'input_attrs' => array(
				'min'   => 1,
				'max'   => 150,
				'step'  => 1,
			),
			'transport' => $selective_refresh,
		)  
	);

	 $wp_customize->add_setting( 'expert_videographer_upgrade_page_settings_99',
        array(
            'sanitize_callback' => 'sanitize_text_field'
        )
    );
    $wp_customize->add_control( new Expert_Videographer_Control_Upgrade(
        $wp_customize, 'expert_videographer_upgrade_page_settings_99',
            array(
                'priority'      => 200,
                'section'       => 'title_tagline',
                'settings'      => 'expert_videographer_upgrade_page_settings_99',
                'label'         => __( 'Expert Videographer Pro comes with additional features.', 'expert-videographer' ),
                'choices'       => array( __( '15+ Ready-Made Sections', 'expert-videographer' ), __( 'One-Click Demo Import', 'expert-videographer' ), __( 'WooCommerce Integrated', 'expert-videographer' ), __( 'Drag & Drop Section Reordering', 'expert-videographer' ),__( 'Advanced Typography Control', 'expert-videographer' ),__( 'Intuitive Customization Options', 'expert-videographer' ),__( '24/7 Support', 'expert-videographer' ), )
            )
        )
    ); 

	/*=========================================
	Expert Videographer Site Identity
	=========================================*/
	$wp_customize->add_section(
        'title_tagline',
        array(
        	'priority'      => 1,
            'title' 		=> __('Site Identity','expert-videographer'),
			'panel'  		=> 'expert_videographer_frontpage_sections',
		)
    );

	$wp_customize->register_panel_type( 'Expert_Videographer_WP_Customize_Panel' );
	$wp_customize->register_section_type( 'Expert_Videographer_WP_Customize_Section' );

}
add_action( 'customize_register', 'expert_videographer_header_settings' );

if ( class_exists( 'WP_Customize_Panel' ) ) {
  	class Expert_Videographer_WP_Customize_Panel extends WP_Customize_Panel {
	   public $panel;
	   public $type = 'expert_videographer_panel';
	   public function json() {

	      $array = wp_array_slice_assoc( (array) $this, array( 'id', 'description', 'priority', 'type', 'panel', ) );
	      $array['title'] = html_entity_decode( $this->title, ENT_QUOTES, get_bloginfo( 'charset' ) );
	      $array['content'] = $this->get_content();
	      $array['active'] = $this->active();
	      $array['instanceNumber'] = $this->instance_number;
	      return $array;
    	}
  	}
}

if ( class_exists( 'WP_Customize_Section' ) ) {
  	class Expert_Videographer_WP_Customize_Section extends WP_Customize_Section {
	   public $section;
	   public $type = 'expert_videographer_section';
	   public function json() {

	      $array = wp_array_slice_assoc( (array) $this, array( 'id', 'description', 'priority', 'panel', 'type', 'description_hidden', 'section', ) );
	      $array['title'] = html_entity_decode( $this->title, ENT_QUOTES, get_bloginfo( 'charset' ) );
	      $array['content'] = $this->get_content();
	      $array['active'] = $this->active();
	      $array['instanceNumber'] = $this->instance_number;

	      if ( $this->panel ) {
	        $array['customizeAction'] = sprintf( 'Customizing &#9656; %s', esc_html( $this->manager->get_panel( $this->panel )->title ) );
	      } else {
	        $array['customizeAction'] = 'Customizing';
	      }
	      return $array;
    	}
  	}
}